/*QSoft Systems (c) 2000
  Gil Dabah and Oren Becker
  http://qsoft.cjb.net
  Compiler- Turbo C++ 3.0

  Hello
  This demo is written in order to show
  you how to use Tripple-Buffering.
  It is REALLY NOT optimized!!!!!!!!!!!!!!

  Thanks to Ari Feldman for the TILES.
*/
#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <alloc.h>

#define SCRNX 320
#define SCRNY 200

unsigned char *VIDEO_ADDRESS = (unsigned char *)0xa0000000l;
unsigned char *scr = NULL;
unsigned char *bkg = NULL;

#define PLAYER_MAX_FRAMES 9
#define player_sprt_w 23
#define player_sprt_h 33
unsigned char playerl_sprts[PLAYER_MAX_FRAMES][player_sprt_w * player_sprt_h];

#define SPDX 4
int px, py, frame, frametime, playerstate;

void init_320x200()
{
 asm{
  mov ax, 0x13
  int 0x10
 }
}

void put_pixel(unsigned int x, unsigned int y, unsigned char col)
{
 if ((x < SCRNX) && (y < SCRNY))
  scr[(y << 8) + (y << 6) + x] = col;
}

void draw_sprite(int x, int y, int w, int h, unsigned char *sprt)
{
 for (int ix = 0; ix < w; ix++)
  for (int iy = 0; iy < h; iy++)
   if (sprt[iy * w +ix]) put_pixel(x + ix, y + iy, sprt[iy * w +ix]);
}

void draw_sprite_mirror(int x, int y, int w, int h, unsigned char *sprt)
{
 for (int ix = 0; ix < w; ix++)
  for (int iy = 0; iy < h; iy++)
   if (sprt[iy * w + (w - ix) - 1]) put_pixel(x + ix, y + iy, sprt[iy * w + (w - ix) - 1]);
}

void clear_screen(unsigned char *buf)
{
 memset(buf, 0, SCRNX * SCRNY);
}

void copy_screen(unsigned char *dst, unsigned char *src)
{
 memcpy(dst, src, SCRNX * SCRNY);
}

void draw_screen(unsigned char *buf)
{
 memcpy(VIDEO_ADDRESS, buf, SCRNX * SCRNY);
}

void init_textmode()
{
 asm{
  mov ax, 0x03
  int 0x10
 }
}

void set_pal(unsigned char index, unsigned char red, unsigned char green, unsigned char blue)
{
 outportb(0x3c8, index);
 outportb(0x3c9, red);
 outportb(0x3c9, green);
 outportb(0x3c9, blue);
}

int loadbkg(char fname[], unsigned char *buf)
{
 FILE* fp;
 unsigned char paldat[768];
 fp = fopen(fname, "rb");
 if (fp == NULL) return(0);
 fread(buf, SCRNX, SCRNY, fp);
 fread(paldat, 768, 1, fp);
 fclose(fp);
 for (int i = 0; i < 256; i++)
  set_pal(i, paldat[(i * 3)], paldat[(i * 3) + 1], paldat[(i * 3) + 2]);
 return(1);
}

void copy_block(unsigned char sprt[player_sprt_w * player_sprt_h], int x, int y, int x2, int y2, unsigned char *buf)
{
 for (int i = 0; i < y2 - y; i++)
  memcpy(&sprt[i * player_sprt_w], &buf[((y + i) << 8) + ((y + i) << 6) + x], x2 - x);
}

int loadplayerframes()
{
 FILE *fp;
 unsigned char *tmp;
 fp = fopen("frames.dat", "rb");
 if (fp == NULL) return(0);
 tmp = (unsigned char *)malloc(SCRNX * SCRNY);
 fread(tmp, SCRNX, SCRNY, fp);
 fclose(fp);
 memset(playerl_sprts, 0, PLAYER_MAX_FRAMES * player_sprt_w * player_sprt_h);
 for (int i = 0; i < PLAYER_MAX_FRAMES; i++)
  copy_block(playerl_sprts[i], i * player_sprt_w + i + 1, 0, (i * player_sprt_w) + player_sprt_w + i + 1, player_sprt_h, tmp);
 free(tmp);
 frame = 0;
 frametime = 0;
 return(1);
}

int main()
{
 int done = 0;
 char key;
 scr = (unsigned char *)malloc(SCRNX * SCRNY);
 if (scr == NULL) return(0);
 bkg = (unsigned char *)malloc(SCRNX * SCRNY);
 if (bkg == NULL) return(0);
 init_320x200();
 clear_screen(scr);
 clear_screen(bkg);
 if (!loadbkg("bkg.dat", bkg)) done = 1;
 playerstate = 0;
 py = 155;
 px = 20;
 if (!loadplayerframes()) done = 1;
 while(!done)
 {
  copy_screen(scr, bkg);
  if (kbhit())
  {
   key = getch();
   if (key == 0) key = getch();
   if ((key == 77) && (px + SPDX < SCRNX - player_sprt_w))
   {
    px += SPDX;
    frame++;
    frame %= PLAYER_MAX_FRAMES;
    playerstate = 1;
    frametime = 0;
   }
   if ((key == 75) && (px > SPDX))
   {
    px -= SPDX;
    frame++;
    frame %= PLAYER_MAX_FRAMES;
    playerstate = 0;
    frametime = 0;
   }
   if (key == 27) done = 1;
  }
  if (frametime++ > 60)
  {
   frame = 0;
   frametime = 0;
  }
  if (playerstate)
   draw_sprite_mirror(px, py, player_sprt_w, player_sprt_h, playerl_sprts[frame]);
  else
   draw_sprite(px, py, player_sprt_w, player_sprt_h, playerl_sprts[frame]);
  draw_screen(scr);
 }
 init_textmode();
 free(bkg);
 free(scr);
 return(1);
}